
#include "waili/Channel.h"
#include "waili/Util.h"


#define XOR(A,B) ((( (A) +128) ^ ( (B) +128)) -128)

void LiftChannelR::Lift_bin(int type ) const
{
  PixType *even = Even,   *odd = Odd, b;
  
  for (u_int i = 0; i < Rows; i++) {    
    if( 1 ) {
      for (u_int j = 0; j < Codd; j++) {
	//even[j] = even[j]  ;
	odd[j] = XOR(even[j], odd[j]) ;
      }
    } else {
      for (u_int j = 0; j < Codd; j++) {
	b=XOR(even[j],  odd[j]);
	even[j] = odd[j] ;
	odd[j] =b;
      }}
     
    even += Ceven;
    odd += Codd;
  }
}



void LiftChannelR::ILift_bin(int type ) const
{
  PixType *even = Even, b;
  PixType *odd = Odd;
  
  for (u_int i = 0; i < Rows; i++) {    
    if( 1 ) {
      for (u_int j = 0; j < Codd; j++) {  
	//odd[j] = even[j]  ^ odd[j] ;
	odd[j] = XOR(even[j], odd[j]) ;
      }} else {
	for (u_int j = 0; j < Codd; j++) {
	  b=XOR(even[j], odd[j]) ;
	  odd[j] = even[j] ;
	  even[j] = b;
	}}
    even += Ceven;
    odd += Codd;
  }
}

void LiftChannelC::Lift_bin(int type ) const
{
  PixType *even = Even;
  PixType *odd = Odd;
  
  for (u_int i = 0; i < Rodd; i++) {    
    for (u_int j = 0; j < Cols; j++)
      odd[j] = XOR(even[j], odd[j]) ; 
    even += Cols;
    odd += Cols;
  }
}

void LiftChannelC::ILift_bin(int type ) const
{
  PixType *even = Even;
  PixType *odd = Odd;
  
  for (u_int i = 0; i < Rodd; i++) {    
    for (u_int j = 0; j < Cols; j++)
      odd[j] = XOR(even[j], odd[j]) ;
    even += Cols;
    odd += Cols;
  }
}


